﻿
If Not InitSound()
  MessageRequester("Erreur","Impossible d'initialiser la bibliothèque son !", 0)
EndIf

UseOGGSoundDecoder() 
UsePNGImageDecoder()
UseJPEGImageDecoder()

Global SL.s = "/"

CompilerIf #PB_Compiler_OS = #PB_OS_MacOS
  If FileSize("Projets") <> -2
    SetCurrentDirectory("../../")  
  EndIf
CompilerEndIf

Global AppDir$ = GetCurrentDirectory()

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  SL = "\"  
CompilerEndIf
  
; Image de capture du backbuffer pour sa restitution
Global finalImage = CreateImage(#PB_Any, 800, 600, 32)

; VARIABLES ----------------------------------------------

Global LeftClick = #False ; Etat du click gauche
Global roll = #False      ; Molette souris
Global KeyEscape = #False
Global KeyReturn = #False
Global KeyUp = #False
Global KeyDown = #False
Global KeyPageUp = #False
Global KeyPageDown = #False
Global KeyBack = #False
Global KeyControl = #False
Global GetKey = 0

Global gameDir$ ; Répertoire où l'on trouve le jeu
Global savedGame$ ; Jeu en cours d'édition

Global Font ; Police du logiciel
Global Dim verb.s(256,10) ; Verbes du vocabulaire
Global Dim msg.s(256) ; Messages texte
Global Dim lieu.s(256) ; Description des Salles
Global Dim dir.i(256,6) ; Numéros de salles vers lequels se diriger (255 = fermé)
Global Dim objet.s(256) ; Noms complets des objets (associables à des mots du vocabulaire)
Global Dim objLieu.i(256) ; Numéro de Salle d'un objet précis
Global Dim sys.s(256) ; Messages système
Global Dim attr.i(256,3) ; Attributs d'objets (vocabulaire associé, prise en inventaire, prise en main)
Global Dim imgLieu.i(256) ; Numéro d'image des lieux
Global Dim flags.i(256) ; Flags des événements (par défaut à 0)
Global Dim ogg.i(256) ; Sons ogg chargés automatiquement
Global Dim chanOgg.i(256) ; Canaux associés aux ogg
Global defaultScreen ; Ecran de jeu par défaut
Global customScreen ; Ecran de jeu par custom
Global useCustomScreen ; Choix de l'écran de jeu (#False = par défaut)
Global Dim cond.s(14) ; Liste des conditions existantes dans les evts
Global Dim act.s(25)  ; Liste des actions existantes dans les evts
Global Dim tenDirs.s(10) ; Liste de 10 dossiers parmis les dossiers dans 'Projets'

Structure Tzone
	x.i
	y.i
	w.i
	h.i
EndStructure

Global zoneImage.Tzone ; Zone des images
Global zoneDescription.Tzone  ; Zone de la description des lieux
Global zoneTexte.Tzone ; Zone de texte
Global zoneInventaire.Tzone ; Zone d'affichage de l'inventaire

Global maxInv ; Maximum d'objets en inventaire
Global maxMain ; Maximum d'objets eb main
Global salle ; Numéro de Salle où se trouve le héros

; Liste des événements mineurs (conditions + actions)
Global Dim numCond.i(25,4,1000) ; Numéro de condition + 3 valeurs x 1000 listes (-1 = pas de condition)
Global Dim numAct.i(25,4,1000) ; Numéro d'action + 3 valeurs x 1000 listes (-1 = pas d'action)
Global condActCount ; Nombre de listes de conditions et d'actions (de 0 à 999)

; Idem pour événements Majeurs
Global Dim numCondMaj.i(25,4,1000) ; Numéro de condition + 3 valeurs x 1000 listes (-1 = pas de condition)
Global Dim numActMaj.i(25,4,1000) ; Numéro d'action + 3 valeurs x 1000 listes (-1 = pas d'action)
Global condActCountMaj ; Nombre de listes de conditions et d'actions (de 0 à 999)

Global Dim EMinVerbe.i(1000) ; Numéro de verbe actif dans les événements mineurs (objet faisant partie du vocabulaire)
Global Dim EMinObjet1.i(1000) ; Numéro d'objet actif dans les événements mineurs (objet faisant partie du vocabulaire)
Global Dim EMinObjet2.i(1000) ; Numéro d'objet actif dans les événements mineurs (objet faisant partie du vocabulaire)

Global yDescription ; Position y de la description
Global yTexte ; Position y du texte
Global yInventaire ; Position y de l'inventaire

Global Dim mot.s(6) ; mots saisis
Global nbmots
Global Dim numeroMot.i(6) ; numéros correspondant au vocabulaire

Global clearScreen
Global invBuffer
Global iv$
Global choixFinDeJeu ; Fin de jeu anticipée ?
Global choixRecommencer ; Recommencer la partie ?
Global compteurActions ; Compte le nombre d'actions effectuées pour terminer le jeu

Global memPhrase$ ; Phrase saisie mémorisée

; Pour récupérer le facteur de Dpi (nécéssite une adaptation potentielle pour fonctionner sous 'LINUX')
Procedure.d ScreenPoint2PixelsY(points.d)
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    Protected hDC  = GetDC_( GetDesktopWindow_() )
    Protected dpiY = GetDeviceCaps_(hDC, #LOGPIXELSY)
    ReleaseDC_(GetDesktopWindow_(), hDC)
    ProcedureReturn (72.0 / dpiY) * points
  CompilerElseIf #PB_Compiler_OS = #PB_OS_Linux
    ProcedureReturn (points * 72.0) / 96.0
  CompilerElse
    ProcedureReturn points
  CompilerEndIf
EndProcedure

; Examiner les événements et le clavier
Procedure ExamineEvents()
  LeftClick = #False
  roll = 0
  KeyEscape = #False
  KeyReturn = #False
  KeyUp = #False
  KeyDown = #False
  KeyPageUp = #False
  KeyPageDown = #False
  KeyBack = #False
  KeyControl = #False
  GetKey = 0
  Event = WindowEvent()
  If Event = #PB_Event_CloseWindow
    CloseWindow(0)
    End
  ElseIf Event = #PB_Event_Gadget
    If EventGadget() = 1
      EventType = EventType()
      If EventType = #PB_EventType_LeftClick
        LeftClick = #True
      ElseIf EventType = #PB_EventType_MouseWheel
        roll = GetGadgetAttribute(1, #PB_Canvas_WheelDelta)
        If GetGadgetAttribute(1, #PB_Canvas_Modifiers) = #PB_Canvas_Control
          KeyControl = #True
        EndIf
      ElseIf EventType = #PB_EventType_KeyUp
        Select GetGadgetAttribute(1, #PB_Canvas_Key)
          Case #PB_Shortcut_Escape
            KeyEscape = #True
          Case #PB_Shortcut_Return
            KeyReturn = #True
          Case #PB_Shortcut_Up
            KeyUp = #True
          Case #PB_Shortcut_Down
            KeyDown = #True
          Case #PB_Shortcut_PageUp
            KeyPageUp = #True
          Case #PB_Shortcut_PageDown
            KeyPageDown = #True
          Case #PB_Shortcut_Back
            KeyBack = #True
        EndSelect
      ElseIf EventType = #PB_EventType_Input
        GetKey = GetGadgetAttribute(1, #PB_Canvas_Input)
      EndIf
    EndIf
  EndIf
EndProcedure

; Runtime error en désactivant les graphiques
Procedure error(m$)
CloseWindow(0)
MessageRequester("Erreur", m$, 0)
End
EndProcedure

; Afficher le buffer image dans le backbuffer et mettre en avant le backuffer
Procedure Flip()
StartDrawing(CanvasOutput(1))
DrawImage(ImageID(0), 0, 0)
StopDrawing()
EndProcedure

Procedure.i GetTextWidth(t.s)
  StartDrawing(ImageOutput(0))
  DrawingFont(FontID(0))
  retval.i = TextWidth(t)
  StopDrawing()
  ProcedureReturn retval
EndProcedure

Procedure.i GetTextHeight(t.s)
  StartDrawing(ImageOutput(0))
  DrawingFont(FontID(0))
  retval.i = TextHeight(t)
  StopDrawing()
  ProcedureReturn retval
EndProcedure

; Affiche un texte en multiligne avec scroll et la couleur souhaitée
Procedure multiLineScrollText(t$,x,y,w,h,margex,margey,ycursor,r,g,b,draw = #True)
If t$ = ""
  ProcedureReturn ycursor
EndIf
buffer = CreateImage(#PB_Any, 800, 600, 32)
buffer = GrabImage(0, #PB_Any, 0, 0, 800, 600)
If useCustomScreen = #False
  StartDrawing(ImageOutput(0))
	DrawImage(ImageID(defaultScreen), 0, 0)
  StopDrawing()	
Else
  StartDrawing(ImageOutput(0))
	DrawImage(ImageID(customScreen), 0, 0)
  StopDrawing()	
EndIf
safeScrollImg = CreateImage(#PB_Any, w - (margex * 2), GetTextHeight("X"), 32)
ytest = y + margey
While ytest < (y + h - (margey * 2) - GetTextHeight("X"))
	ytest + GetTextHeight("X")
Wend
ytest - GetTextHeight("X")
safeScrollImg = GrabImage(0, #PB_Any, x + margex, ytest, w - (margex * 2), GetTextHeight("X")) ; Buffer de la taille d'une ligne de texte
StartDrawing(ImageOutput(0))
DrawImage(ImageID(buffer), 0, 0)
FrontColor(RGB(r,g,b))
DrawingMode(#PB_2DDrawing_Transparent)
DrawingFont(FontID(0))
tvert = ycursor ; taille verticale du texte
While Len(t$) > 0
	a$ = ""
	While TextWidth(a$) < (w - (margex * 2)) And t$ <> ""
		a$ = a$ + Left(t$,1)
		t$ = Mid(t$,2)
	Wend
	If a$ = ""
	  Break
	EndIf
	If TextWidth(a$) > (w - (margex * 2))
		t$ = Right(a$,1) + t$
		a$ = Left(a$,Len(a$)-1) 
	EndIf
	If Len(t$) > 0
		a2$ = a$
		t2$ = t$
		While Left(t$,1) <> " " And a$ <> ""
			t$ = Right(a$,1) + t$
			a$ = Left(a$,Len(a$)-1) 		
		Wend
		If a$ <> ""
			t$ = Mid(t$,2)
		Else
			t$ = t2$
			a$ = a2$
		EndIf
	EndIf
	tvert + TextHeight(a$)
	If tvert > (h - (margey * 2))
		tempScrollImg = CreateImage(#PB_Any, w - (margex * 2), h - (margey * 2) - TextHeight("X"), 32)
		While tvert > (h - (margey * 2))
		  StopDrawing()
		  ; Récupération de tout le texte moins la ligne d'en haut
		  tempScrollImg = GrabImage(0, #PB_Any, x + margex, y + margey + GetTextHeight("X"), w - (margex * 2), h - (margey * 2) - GetTextHeight("X"))
		  StartDrawing(ImageOutput(0))
      FrontColor(RGB(r,g,b))
      DrawingFont(FontID(0))
		  ; Affichage décalé en haut, pour scroller
			DrawImage(ImageID(tempScrollImg), x + margex, y + margey)
			DrawImage(ImageID(safeScrollImg), x + margex, ytest)
			tvert - TextHeight("X")
		Wend
		FrontColor(RGB(r,g,b))
 		DrawingMode(#PB_2DDrawing_Transparent)
		If draw
		  DrawText(x + margex, y + margey + tvert - TextHeight(a$), a$)
		EndIf
	Else
	  If draw
	    DrawText(x + margex, y + margey + tvert - TextHeight(a$), a$)
	  EndIf
	EndIf 
Wend
StopDrawing()	
ProcedureReturn tvert
EndProcedure

; Initialiser les données
Procedure init()
For i = 0 To 255
	For j = 0 To 9
		verb(i,j) = ""
	Next
	msg(i) = ""
	lieu(i) = ""
	For j = 0 To 5
		dir(i,j) = 255
	Next
	objet(i) = ""
	objLieu(i) = 253
	sys(i) = ""
	attr(i,0) = 255
	attr(i,1) = #False
	attr(i,2) = #False
Next
For i = 0 To 24
	For j = 0 To 999
		numCond(i,0,j) = -1
		numCond(i,1,j)= 255
		numCond(i,2,j) = 255
		numCond(i,3,j) = 255
		numAct(i,0,j) = -1
		numAct(i,1,j) = 255
		numAct(i,2,j) = 255
		numAct(i,3,j) = 255
		numCondMaj(i,0,j) = -1
		numCondMaj(i,1,j) = 255
		numCondMaj(i,2,j) = 255
		numCondMaj(i,3,j) = 255
		numActMaj(i,0,j) = -1
		numActMaj(i,1,j) = 255
		numActMaj(i,2,j) = 255
		numActMaj(i,3,j) = 255
	Next
Next
For i = 0 To 999
	EMinVerbe(i) = 255
	EMinObjet1(i) = 255
	EMinObjet2(i) = 255
Next
salle = 0
cond(0) = "En salle *"
cond(1) = "En salle inférieure à *"
cond(2) = "En salle supérieure à *"
cond(3) = "Flag * égal à zéro"
cond(4) = "Flag * pas égal à zéro"
cond(5) = "Flag * < *"
cond(6) = "Flag * = *"
cond(7) = "Flag * > *"
cond(8) = "Objet * en inventaire"
cond(9) = "Objet * en main"
cond(10) = "Objet * ici"
cond(11) = "Objet * pas en inventaire"
cond(12) = "Objet * pas en main"
cond(13) = "Objet * pas ici"
act(0) = "Affiche Ok"
act(1) = "Affiche inventaire"
act(2) = "Affiche message *"
act(3) = "Affiche * au flag *"
act(4) = "Aller en *"
act(5) = "Attendre touche"
act(6) = "Crée objet *"
act(7) = "Crée objet * en *"
act(8) = "Décrit salle actuelle"
act(9) = "Détruit objet *"
act(10) = "Echange objet * et *"
act(11) = "Efface flag *"
act(12) = "Efface écran"
act(13) = "Salle * prend image n° *"
act(14) = "Finir le jeu"
act(15) = "Flag * = *"
act(16) = "Jette objet *"
act(17) = "Jette tout"
act(18) = "Met flag *"
act(19) = "Objet * en main"
act(20) = "Objet * non en main"
act(21) = "Pause *"
act(22) = "Prends objet *"
act(23) = "Quitter jeu"
act(24) = "Jouer sample ogg *"
verb(0,0) = "N"
verb(0,1) = "NORD"
verb(1,0) = "S"
verb(1,1) = "SUD"
verb(2,0) = "E"
verb(2,1) = "EST"
verb(3,0) = "O"
verb(3,1) = "OUEST"
verb(4,0) = "H"
verb(4,1) = "HAUT"
verb(5,0) = "B"
verb(5,1) = "BAS"
verb(6,0) = "PRENDS"
verb(7,0) = "LAISSE"
verb(7,1) = "JETTE"
verb(8,0) = "RANGE"
verb(9,0) = "MANIE"
verb(10,0) = "INVENTAIRE"
verb(10,1) = "I"
verb(11,0) = "FIN"
verb(11,1) = "ARRET"
verb(12,0) = "SAUVE"
verb(12,1) = "SAVE"
verb(13,0) = "CHARGE"
verb(13,1) = "LOAD"
verb(14,0) = "ALLUME"
verb(15,0) = "ETEINS"
msg(0) = "Message 0."
lieu(0) = "Vous vous trouvez à l'entrée du château."
lieu(1) = "A la lisière de la forêt."
lieu(2) = "Dans la cours du château."
lieu(3) = "L'entrée d'une prison."
lieu(4) = "Une pharmacie."
lieu(5) = "Une petite salle rectangulaire."
lieu(6) = "La princesse dans sa cellule, maintenant LIBRE."
lieu(253) = "Non créé."
lieu(254) = "En inventaire."
lieu(255) = "En main."
objet(0) = "Une épée"
objet(1) = "La clef"
objet(2) = "Un garde devant l'entrée"
objet(3) = "Le garde mort"
objet(4) = "Un dragon avec une clef autour du cou"
objet(5) = "Le dragon endormi"
sys(0) = "Vous voyez :"
sys(1) = "A vous :"
sys(2) = "Je ne comprends pas ces mots."
sys(3) = "Je ne peux pas aller pas là."
sys(4) = "Je ne peux pas"
sys(5) = "Vous avez:"
sys(6) = "(en main)"
sys(7) = "Rien du tout"
sys(8) = "Voulez-vous vraiment arrêter le jeu ?"
sys(9) = "Fin de la partie - Voulez-vous rejouer ?"
sys(10) = "Pressez une touche"
sys(11) = "Vous avez fait"
sys(12) = "action"
sys(13) = "s"
sys(14) = "Vous n'avez pas cet objet en main."
sys(15) = "Vous ne pouvez pas, vos mains sont pleines."
sys(16) = "Vous l'avez déjà."
sys(17) = "Cet objet n'est pas ici."
sys(18) = "Vous ne pouvez pas avoir plus d'objets."
sys(19) = "Vous ne l'avez pas."
sys(20) = "Vous portez déjà cet objet."
sys(21) = "O"
sys(22) = "N"
sys(23) = "Numéro de sauvegarde (1 à 9) :"
sys(24) = "D'accord."
sys(25) = "Vous ne pouvez pas écrire sur ce disque."
EndProcedure

; Mettre à jour les dossiers de jeux
Procedure updatedDirs(ydir,count)
nbrep = 0
d = ExamineDirectory(#PB_Any, AppDir$+"Projets","")
If d = 0
  error("Le repertoire 'Projets' est manquant !")
Else
  While NextDirectoryEntry(d)
	  If DirectoryEntryType(d) = #PB_DirectoryEntry_Directory
    t$ = DirectoryEntryName(d)
    	If t$ <> "." And t$ <> ".." And t$ <> "Sans Titre"
      	If FileSize(AppDir$+"Projets"+SL+t$) = -2
	       nbrep + 1
      	EndIf
      EndIf
    EndIf
  Wend
  FinishDirectory(d)
EndIf 
If nbrep = 0
	nbrep = 1
EndIf
Dim rep.s(nbrep)
rep(0) = ""
If nbrep > 0
	nbrep = 0
	d = ExamineDirectory(#PB_Any, AppDir$+"Projets","")
	If d = 0
    error("Le repertoire 'Projets' est manquant !")
  Else
    While NextDirectoryEntry(d)
	    If DirectoryEntryType(d) = #PB_DirectoryEntry_Directory
        t$ = DirectoryEntryName(d)
    	  If t$ <> "." And t$ <> ".." And t$ <> "Sans Titre"
      	  If FileSize(AppDir$+"Projets"+SL+t$) = -2
      			rep(nbrep) = t$
	         nbrep + 1
        	EndIf
        EndIf
      EndIf
    Wend
    FinishDirectory(d)
  EndIf
EndIf 
While ydir + count > nbrep
	ydir - 1
Wend
If ydir < 0
  ydir = 0
EndIf
For i = ydir To ydir + count - 1
	If i < nbrep
		tenDirs(i - ydir) = rep(i)
	EndIf
Next
baseDir = ydir
EndProcedure

; Charger fichier .jad
Procedure.s loadJad(nom$, rep$) 
If nom$ = ""
	rep$ = ""
	d = ExamineDirectory(#PB_Any, AppDir$, "")
	If d = 0
    error("Impossible d'ouvrir le dossier courant !")
  Else
    While NextDirectoryEntry(d)
	    If DirectoryEntryType(d) = #PB_DirectoryEntry_File
        t$ = DirectoryEntryName(d)
    		If t$ <> "." And t$ <> ".."
      		If LCase(Right(t$,4)) = ".jad"
			      nom$ = t$
      			Break
      		EndIf
      	EndIf
      EndIf
    Wend
    FinishDirectory(d)
  EndIf
  If nom$ = ""
    error("Impossible de trouver un fichier d'aventure .jad")
  EndIf
EndIf
If FileSize(AppDir$+rep$+nom$) = -1
	error("Fichier '" + rep$ + nom$ + "' introuvable !")
EndIf
fic = ReadFile(#PB_Any, AppDir$+rep$+nom$)
If fic = 0
  error("Impossible d'ouvrir le fichier '" + rep$ + nom$ + "' !")
EndIf
init()
For i = 0 To 255
	For j = 0 To 9
		If Not Eof(fic)
			verb(i,j) = ReadString(fic)
		Else
			error("Fichier corrompu !")
		EndIf
	Next
	If Not Eof(fic)
		msg(i) = ReadString(fic)
	Else
		error("Fichier corrompu !")
	EndIf
	If Not Eof(fic)
		lieu(i) = ReadString(fic)
	Else
		error("Fichier corrompu !")
	EndIf
	For j = 0 To 5
		If Not Eof(fic)
			dir(i,j) = Val(ReadString(fic))
		Else
			error("Fichier corrompu !")
		EndIf
	Next
	If Not Eof(fic)
		objet(i) = ReadString(fic)
	Else
		error("Fichier corrompu !")
	EndIf
	If Not Eof(fic)
		objLieu(i) = Val(ReadString(fic))
	Else
		error("Fichier corrompu !")
	EndIf
	If Not Eof(fic)
		sys(i) = ReadString(fic)
	Else
		error("Fichier corrompu !")
	EndIf
	For j = 0 To 2
		If Not Eof(fic)
			attr(i,j) = Val(ReadString(fic))
		Else
			error("Fichier corrompu !")
		EndIf
	Next
Next
If Not Eof(fic)
	zoneImage\x = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneImage\y = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneImage\w = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneImage\h = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneDescription\x = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneDescription\y = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneDescription\w = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneDescription\h = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneTexte\x = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneTexte\y = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneTexte\w = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneTexte\h = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneInventaire\x = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneInventaire\y = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneInventaire\w = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	zoneInventaire\h = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	maxInv = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	maxMain = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	condActCount = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
For k = 0 To condActCount - 1
	If Not Eof(fic)
		EMinVerbe(k) = Val(ReadString(fic))
	Else
		error("Fichier corrompu !")
	EndIf
	If Not Eof(fic)
		EMinObjet1(k) = Val(ReadString(fic))
	Else
		error("Fichier corrompu !")
	EndIf
	If Not Eof(fic)
		EMinObjet2(k) = Val(ReadString(fic))
	Else
		error("Fichier corrompu !")
	EndIf
Next
For i = 0 To 24
	For j = 0 To 3
		For k = 0 To condActCount - 1
			If Not Eof(fic)
				numCond(i,j,k) = Val(ReadString(fic))
			Else
				error("Fichier corrompu !")
			EndIf
			If Not Eof(fic)
				numAct(i,j,k) = Val(ReadString(fic))
			Else
				error("Fichier corrompu !")
			EndIf
		Next
	Next
Next
If Not Eof(fic)
	condActCountMaj = Val(ReadString(fic))
Else
	error("Fichier corrompu !")
EndIf
For i = 0 To 24
	For j = 0 To 3
		For k = 0 To condActCountMaj - 1
			If Not Eof(fic)
				numCondMaj(i,j,k) = Val(ReadString(fic))
			Else
				error("Fichier corrompu !")
			EndIf
			If Not Eof(fic)
				numActMaj(i,j,k) = Val(ReadString(fic))
			Else
				error("Fichier corrompu !")
			EndIf
		Next
	Next
Next
CloseFile(fic)
ProcedureReturn nom$
EndProcedure

; Tester une condition
Procedure testCondition(c.i, p1.i, p2.i, p3.i)
Select c
	Case 0
		If salle = p1
	    ProcedureReturn #True
	  EndIf
	Case 1
		If salle < p1
	    ProcedureReturn #True
	  EndIf
	Case 2
		If salle > p1
	    ProcedureReturn #True
	  EndIf
	Case 3
		If flags(p1) = 0
	    ProcedureReturn #True
	  EndIf
	Case 4
		If flags(p1) <> 0
	    ProcedureReturn #True
	  EndIf
	Case 5
		If flags(p1) < p2
	    ProcedureReturn #True
	  EndIf
	Case 6
		If flags(p1) = p2
	    ProcedureReturn #True
	  EndIf
	Case 7
		If flags(p1) > p2
	    ProcedureReturn #True
	  EndIf
	Case 8
		If objLieu(p1) = 254
	    ProcedureReturn #True
	  EndIf
	Case 9
		If objLieu(p1) = 255
	    ProcedureReturn #True
	  EndIf
	Case 10
		If objLieu(p1) = salle
	    ProcedureReturn #True
	  EndIf
	Case 11
		If objLieu(p1) <> 254
	    ProcedureReturn #True
	  EndIf
	Case 12
	  If objLieu(p1) <> 255
	    ProcedureReturn #True
	  EndIf
	Case 13
	  If objLieu(p1) <> salle
	    ProcedureReturn #True
	  EndIf
EndSelect
ProcedureReturn #False
EndProcedure

; Lowcase de la première lettre
Procedure.s lowStart(a$)
If Len(a$) > 0
	a$ = LCase(Left(a$,1))+Mid(a$,2)
EndIf
ProcedureReturn a$
EndProcedure

; Highcase de la première lettre
Procedure.s highStart(a$)
If Len(a$) > 0
	a$ = UCase(Left(a$,1))+Mid(a$,2)
EndIf
ProcedureReturn a$
EndProcedure

; Trouver et convertir en texte les directions possibles
Procedure.s findDirections(s.i)
t$ = ""
If dir(s,0) < 253
  t$ + "N"
EndIf
If dir(s,1) < 253
  t$ + "S"
EndIf
If dir(s,2) < 253
    t$ + "E"
EndIf
If dir(s,3) < 253
  t$ + "O"
EndIf
If dir(s,4) < 253
  t$ + "H"
EndIf
If dir(s,5) < 253
  t$ + "B"
EndIf
If t$ = ""
  ProcedureReturn t$
EndIf
t$ = " <" + t$ + ">"
ProcedureReturn t$
EndProcedure

; Retrouver une liste d'objet dans une salle précise (ou en inventaire)
Procedure.s getObjectList(salle.i)
lst$ = ""
virgule$ = ""
For i = 0 To 255
	If objLieu(i) = salle And salle < 253
		lst$ + virgule$
		lst$ + lowStart(objet(i))
		virgule$ = ", "
	ElseIf objLieu(i) > 253 And salle > 253
		lst$ + virgule$
		lst$ + lowStart(objet(i))
		virgule$ = ", "
	EndIf
Next
ProcedureReturn highStart(lst$)
EndProcedure

; Effectuer une action
Procedure performAction(a.i, p1.i, p2.i, p3.i)
Select a
	Case 0
		yTexte = multiLineScrollText(sys(24),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
	Case 1
		yInventaire = 0
		iv$ = getObjectList(254)
		If iv$ = ""
		  iv$ = sys(7)
		EndIf
		StartDrawing(ImageOutput(0))
		DrawImage(ImageID(invBuffer),zoneInventaire\x,zoneInventaire\y)
		StopDrawing()
		yInventaire = multiLineScrollText(sys(5)+" "+iv$,zoneInventaire\x,zoneInventaire\y,zoneInventaire\w,zoneInventaire\h,2,2,yInventaire,0,0,0)	
	Case 2
		yTexte = multiLineScrollText(msg(p1),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
	Case 3
		flags(p1) = Mod((flags(p1) + flags(p2)), 256)
	Case 4
		salle = p1
		clearScreen = #True
	Case 5
		finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
		Flip()
		StartDrawing(ImageOutput(0))
		DrawImage(ImageID(finalImage), 0, 0)
		ExamineEvents()
		While Anykey = #False
		  Delay(1)
		  ExamineEvents()
		Wend
	Case 6
		yInventaire = 0
		objLieu(p1) = salle
		iv$ = getObjectList(salle)
		If iv$ = ""
		  iv$ = sys(7)
		EndIf
		StartDrawing(ImageOutput(0))
		DrawImage(ImageID(invBuffer),zoneInventaire\x,zoneInventaire\y)
		StopDrawing()
		yInventaire = multiLineScrollText(sys(0)+" "+iv$,zoneInventaire\x,zoneInventaire\y,zoneInventaire\w,zoneInventaire\h,2,2,yInventaire,0,0,0)
	Case 7
		yInventaire = 0
		objLieu(p1) = p2
		iv$ = getObjectList(salle)
		If iv$ = ""
		  iv$ = sys(7)
		EndIf
		StartDrawing(ImageOutput(0))
		DrawImage(ImageID(invBuffer),zoneInventaire\x,zoneInventaire\y)
		StopDrawing()
		yInventaire = multiLineScrollText(sys(0)+" "+iv$,zoneInventaire\x,zoneInventaire\y,zoneInventaire\w,zoneInventaire\h,2,2,yInventaire,0,0,0)
	Case 8
	  If useCustomScreen = #False
	    StartDrawing(ImageOutput(0))
	    DrawImage(ImageID(defaultScreen), 0, 0)
	    StopDrawing()
		Else
	    StartDrawing(ImageOutput(0))
			DrawImage(ImageID(customScreen), 0, 0)
	    StopDrawing()
		EndIf
		invBuffer = GrabImage(0, #PB_Any, zoneInventaire\x, zoneInventaire\y, zoneInventaire\w,zoneInventaire\h)
		screenBuffer = CreateImage(#PB_Any, 800, 600, 32)
		textBuffer = CreateImage(#PB_Any, zoneTexte\w - 4,GetTextHeight("X"), 32)
		screenBuffer = GrabImage(0, #PB_Any, 0, 0, 800, 600)
		yDescription = 0
		yTexte = 0
		yInventaire = 0
		clearScreen = #False
    StartDrawing(ImageOutput(0))
	  DrawImage(ImageID(screenBuffer), 0, 0)
	  StopDrawing()
		If FileSize(Str(salle)+".jpg") > 0
			tempImg = LoadImage(#PB_Any, Str(imgLieu(salle))+".jpg")
      StartDrawing(ImageOutput(0))
			DrawImage(ImageID(tempImg), zoneImage\x, zoneImage\y, zoneImage\w, zoneImage\h)
  	  StopDrawing()
		EndIf
		yDescription = multiLineScrollText(lieu(salle) + findDirections(salle),zoneDescription\x,zoneDescription\y,zoneDescription\w,zoneDescription\h,2,2,yDescription,0,0,0)
		iv$ = getObjectList(salle)
		If iv$ = ""
		  iv$ = sys(7)
		EndIf
    StartDrawing(ImageOutput(0))
		DrawImage(ImageID(invBuffer),zoneInventaire\x,zoneInventaire\y)
	  StopDrawing()
		yInventaire = multiLineScrollText(sys(0)+" "+iv$,zoneInventaire\x,zoneInventaire\y,zoneInventaire\w,zoneInventaire\h,2,2,yInventaire,0,0,0)
		yTexte = multiLineScrollText(sys(1),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0) ; A vous :
		yTexte = multiLineScrollText(memPhrase$,zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0) ; Verbe effectué
	Case 9
		objLieu(p1) = 253
	Case 10
	  Swap objLieu(p1), objLieu(p2)
	Case 11
		flags(p1) = 0
	Case 12
	  If useCustomScreen = #False
	    StartDrawing(ImageOutput(0))
	    DrawImage(ImageID(defaultScreen), 0, 0)
	    StopDrawing()
		Else
	    StartDrawing(ImageOutput(0))
			DrawImage(ImageID(customScreen), 0, 0)
	    StopDrawing()
		EndIf
		invBuffer = GrabImage(0, #PB_Any, zoneInventaire\x, zoneInventaire\y, zoneInventaire\w, zoneInventaire\h)
		screenBuffer = CreateImage(#PB_Any , 800, 600, 32)
		textBuffer = CreateImage(zoneTexte\w - 4,GetTextHeight("X"), 32)
		screenBuffer = GrabImage(0, #PB_Any, 0, 0, 800, 600)
		yDescription = 0
		yTexte = 0
		yInventaire = 0
		clearScreen = #False
		StartDrawing(ImageOutput(0))
		DrawImage(ImageID(screenBuffer), 0, 0)
		StopDrawing()
		If FileSize(Str(salle)+".jpg") > 0
			tempImg = LoadImage(#PB_Any, Str(imgLieu(salle))+".jpg")
      StartDrawing(ImageOutput(0))
			DrawImage(ImageID(tempImg), zoneImage\x, zoneImage\y, zoneImage\w, zoneImage\h)
  	  StopDrawing()
		EndIf
	Case 13
		imgLieu(p1) = p2
	  If useCustomScreen = #False
	    StartDrawing(ImageOutput(0))
	    DrawImage(ImageID(defaultScreen), 0, 0)
	    StopDrawing()
		Else
	    StartDrawing(ImageOutput(0))
			DrawImage(ImageID(customScreen), 0, 0)
	    StopDrawing()
		EndIf
		invBuffer = GrabImage(0, #PB_Any, zoneInventaire\x, zoneInventaire\y, zoneInventaire\w, zoneInventaire\h)
		screenBuffer = CreateImage(#PB_Any , 800, 600, 32)
		textBuffer = CreateImage(zoneTexte\w - 4,GetTextHeight("X"), 32)
		screenBuffer = GrabImage(0, #PB_Any, 0, 0, 800, 600)
		yDescription = 0
		yTexte = 0
		yInventaire = 0
		clearScreen = #False
		StartDrawing(ImageOutput(0))
		DrawImage(ImageID(screenBuffer), 0, 0)
		StopDrawing()
		If FileSize(Str(salle)+".jpg") > 0
			tempImg = LoadImage(#PB_Any, Str(imgLieu(salle))+".jpg")
      StartDrawing(ImageOutput(0))
			DrawImage(ImageID(tempImg), zoneImage\x, zoneImage\y, zoneImage\w, zoneImage\h)
  	  StopDrawing()
		EndIf
		yDescription = multiLineScrollText(lieu(salle) + findDirections(salle),zoneDescription\x,zoneDescription\y,zoneDescription\w,zoneDescription\h,2,2,yDescription,0,0,0)
		iv$ = getObjectList(salle)
		If iv$ = ""
		  iv$ = sys(7)
		EndIf
    StartDrawing(ImageOutput(0))
		DrawImage(ImageID(invBuffer),zoneInventaire\x,zoneInventaire\y)
	  StopDrawing()
		yInventaire = multiLineScrollText(sys(0)+" "+iv$,zoneInventaire\x,zoneInventaire\y,zoneInventaire\w,zoneInventaire\h,2,2,yInventaire,0,0,0)
		yTexte = multiLineScrollText(sys(1),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0) ; A vous :
		yTexte = multiLineScrollText(memPhrase$,zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0) ; Verbe effectué
	Case 14
		m$ = sys(11) + " " + Str(compteurActions) + " " + sys(12)
		If compteurActions > 1
		  m$ + sys(13)
		EndIf
		yTexte = multiLineScrollText(m$,zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
		yTexte = multiLineScrollText(sys(9),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
		yTexte = multiLineScrollText(sys(21)+"/"+sys(22),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
		choixRecommencer = #True
	Case 15
		flags(p1) = p2
	Case 16
		If objLieu(p1) = 254 Or objLieu(p1) = 255
			objLieu(p1) = salle
		EndIf
	Case 17
		For i = 0 To 255
			If objLieu(i) = 254 Or objLieu(i) = 255
				objLieu(i) = salle
			EndIf
		Next
	Case 18
		flags(p1) = 255
	Case 19
		If objLieu(p1) = 254
			objLieu(p1) = 255
		EndIf	
	Case 20
		If objLieu(p1) = 255
			objLieu(p1) = 254
		EndIf	
	Case 21
		finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
		Flip()
		DrawImage(ImageID(finalImage), 0, 0)
		Delay(p1 * 1000)
	Case 22
		If objLieu(p1) = salle
			objLieu(p1) = 254
		EndIf	
	Case 23
		yTexte = multiLineScrollText(sys(8),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
		yTexte = multiLineScrollText(sys(21)+"/"+sys(22),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
		choixFinDeJeu = #True
	Case 24
	  If chanOgg(p1)
	    StopSound(ogg(p1), chanOgg(p1))
	  EndIf
	  If ogg(p1)
	    chanOgg(p1) = PlaySound(ogg(p1))
	  EndIf
EndSelect
EndProcedure

; Décompose phrase en 6 mots dans mot()
Procedure decomposerPhrase(p$)
For i = 0 To 5
	mot(i) = ""
Next
nbmots = 0
p2$ = ""
For i = 1 To Len(p$)
	If Mid(p$,i,1) >= "A" And Mid(p$,i,1) <= "Z"
		p2$ + Mid(p$,i,1)
	Else
		p2$ + " "
	EndIf
Next
p$ = Trim(p2$)
If p$= ""
  ProcedureReturn
EndIf
i = 0
j = 1
While i < 6
	If Mid(p$,j,1) = " "
		mot(i) = Mid(p$,1,j - 1)
		p$ = Mid(p$,j + 1)
		p$ = Trim(p$)
		i + 1
		j = 1
	Else
		j + 1
		If j >= Len(p$)
			mot(i) = p$
			p$ = Trim(p$)
			i + 1
			Break
		EndIf
	EndIf
Wend
nbmots = i
EndProcedure

; Tester les événements majeurs
Procedure EvenementsMajeurs()
For k = 0 To condActCountMaj - 1
	ok = #True
	For i = 0 To 24
	  If numCondMaj(i,0,k) = -1
	    Break
	  EndIf
		If testCondition(numCondMaj(i,0,k),numCondMaj(i,1,k),numCondMaj(i,2,k),numCondMaj(i,3,k)) = #False
			ok = #False
			Break
		EndIf
	Next
	If ok = #True
		For i = 0 To 24
		  If numActMaj(i,0,k) = -1
		    Break
		  Else
		    performAction(numActMaj(i,0,k),numActMaj(i,1,k),numActMaj(i,2,k),numActMaj(i,3,k))
		  EndIf
		Next		
	EndIf
Next
EndProcedure

; Tester les événements mineurs
Procedure EvenementsMineurs(o1,o2,o3)
For k = 0 To condActCount - 1
	If EMinVerbe(k) = o1 And EMinObjet1(k) = o2 And EMinObjet2(k) = o3
		ok = #True
		For i = 0 To 24
		  If numCond(i,0,k) = -1
		    Break
		  EndIf
			If testCondition(numCond(i,0,k),numCond(i,1,k),numCond(i,2,k),numCond(i,3,k)) = #False
				ok = #False
			  Break	
			EndIf
		Next
		If ok = #True
			For i = 0 To 24
			  If numAct(i,0,k) = -1
			    Break
			  Else
			    performAction(numAct(i,0,k),numAct(i,1,k),numAct(i,2,k),numAct(i,3,k))
			  EndIf
			Next
		EndIf		
	EndIf
Next
EndProcedure

; Trouve un objet s'il est dans la salle courante
Procedure.i trouveObjet(o.i, s.i)
For i = 0 To 255
  If attr(i,0) = o And objLieu(i) = s
    ProcedureReturn i
  EndIf
Next
ProcedureReturn -1 
EndProcedure

; Compte les objets en inventaire
Procedure invCount()
i = 0
For j = 0 To 255
  If objLieu(j) = 254
    i + 1
  EndIf
Next
ProcedureReturn i
EndProcedure

; Compte les objets en main
Procedure mainCount()
i = 0
For j = 0 To 255
  If objLieu(j) = 255
    i + 1
  EndIf
Next
ProcedureReturn i
EndProcedure

; Charger une partie
Procedure.i LoadAGame(nom$)
If FileSize(nom$) = -1 And Val(Left(nom$,1)) > 0
  ProcedureReturn #False
EndIf
fic = ReadFile(#PB_Any, nom$,#PB_Ascii)
If fic = 0
  error("Impossible d'ouvrir le fichier "+nom$+" !")
EndIf
If Not Eof(fic)
	compteurActions = ReadInteger(fic)
Else
	error("Fichier corrompu !")
EndIf
If Not Eof(fic)
	salle = ReadInteger(fic)
Else
	error("Fichier corrompu !")
EndIf
For i = 0 To 255
	If Not Eof(fic)
		objLieu(i) = ReadInteger(fic)
	Else
		error("Fichier corrompu !")
	EndIf
	If Not Eof(fic)
		imgLieu(i) = ReadInteger(fic)
	Else
		error("Fichier corrompu !")
	EndIf
	If Not Eof(fic)
		flags(i) = ReadInteger(fic)
	Else
		error("Fichier corrompu !")
	EndIf
Next
CloseFile(fic)
ProcedureReturn #True
EndProcedure

; Sauvegarder une partie
Procedure.i SaveAGame(nom$)
If FileSize(nom$) > 0
  DeleteFile(nom$)
EndIf
fic = CreateFile(#PB_Any, nom$,#PB_Ascii)
If fic = 0
  ProcedureReturn #False
EndIf
WriteInteger(fic,compteurActions)
WriteInteger(fic,salle)
For i = 0 To 255
	WriteInteger(fic,objLieu(i))
	WriteInteger(fic,imgLieu(i))
	WriteInteger(fic,flags(i))
Next
CloseFile(fic)
ProcedureReturn #True
EndProcedure

; FONCTIONS PRINCIPALES ----------------------------------------------

; Ouverture de la fenêtre graphique
Procedure.i InitScreen()
If Not OpenWindow(0, 0, 0, 800, 600, "", #PB_Window_TitleBar | #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
	ProcedureReturn #False
EndIf
CanvasGadget(1, 0, 0, 800, 600, #PB_Canvas_DrawFocus | #PB_Canvas_Keyboard)
SetActiveGadget(1)
If Not CreateImage(0, 800, 600, 32)
  CloseWindow(0)
  ProcedureReturn #False
EndIf
ProcedureReturn #True
EndProcedure

; Charger la police par défaut
Procedure LoadFonts()
If Not LoadFont(0, "Fonts/DroidSansMono.ttf", ScreenPoint2PixelsY(16))
  ProcedureReturn #False
EndIf
ProcedureReturn #True
EndProcedure

; Initialisation
Procedure loadDefault()
defaultScreen = LoadImage(#PB_Any, "Images"+ SL +"ecran.jpg")
If defaultScreen = 0
  ProcedureReturn #False
EndIf
useCustomScreen = #False
savedGame$ = ""
ProcedureReturn #True
EndProcedure

; Tester/interpréter le jeu
Procedure menuTestGame()
For i = 0 To 255
	If FileSize(Str(i)+".ogg") > 0
		ogg(i) = LoadSound(#PB_Any, Str(i)+".ogg")
	Else
		ogg(i) = 0
	EndIf
Next
For i= 0 To 5
	mot(i) = ""
Next
nbmots = 0 ; Nombre de mots dans la phrase (6 maxi validés)
yDescription = 0
yTexte = 0
yInventaire = 0
salle = 0
For i = 0 To 255
	imgLieu(i) = i
	flags(i) = 0
Next
If FileSize("ecran.jpg") > 0
	customScreen = LoadImage(#PB_Any, "ecran.jpg")
	useCustomScreen = #True
Else
	useCustomScreen = #False
EndIf
sortir = #False
StartDrawing(CanvasOutput(1))
Box(0, 0, 800, 600)
StopDrawing()
If FileSize("introduction.ogg") > 0
	tempSound = LoadSound(#PB_Any, "introduction.ogg")
	tempChan = PlaySound(tempSound, #PB_Sound_MultiChannel)
EndIf
If FileSize("introduction.jpg") > 0
  tempImg = LoadImage(#PB_Any, "introduction.jpg")
  ExamineEvents()
	While KeyEscape = #False And KeyReturn = #False
    StartDrawing(ImageOutput(0))
    DrawImage(ImageID(tempImg), 0, 0)
    StopDrawing()
  	Flip()
    ExamineEvents()
		Delay(1)
	Wend
EndIf
clearScreen = #True
invBuffer = CreateImage(#PB_Any, zoneInventaire\w, zoneInventaire\h , 32)
compteurActions = 0 ; Compte le nombre d'actions effectuées pour terminer le jeu
choixFinDeJeu = #False
choixRecommencer = #False
activateWaitKey = #False
If SaveAGame("0.sav") = #False
  error("Impossible de faire la sauvegarde du jeu !")
EndIf
Repeat
	If clearScreen = #True
	  If useCustomScreen = #False
	    StartDrawing(ImageOutput(0))
	    DrawImage(ImageID(defaultScreen), 0, 0)
	    StopDrawing()
		Else
	    StartDrawing(ImageOutput(0))
	    DrawImage(ImageID(customScreen), 0, 0)
	    StopDrawing()
		EndIf
		invBuffer = GrabImage(0, #PB_Any, zoneInventaire\x, zoneInventaire\y, zoneInventaire\w, zoneInventaire\h)
		screenBuffer = CreateImage(#PB_Any, 800, 600, 32)
		textBuffer = CreateImage(#PB_Any, zoneTexte\w - 4, GetTextHeight("X"), 32)
		screenBuffer = GrabImage(0, #PB_Any, 0, 0, 800, 600)
		yDescription = 0
		yTexte = 0
		yInventaire = 0
		clearScreen = #False
	EndIf
	StartDrawing(ImageOutput(0))
	DrawImage(ImageID(screenBuffer), 0, 0)
	StopDrawing()
	If FileSize(Str(salle)+".jpg") > 0
 		tempImg = LoadImage(#PB_Any, Str(imgLieu(salle))+".jpg")
	  StartDrawing(ImageOutput(0))
  	DrawImage(ImageID(tempImg),zoneImage\x,zoneImage\y,zoneImage\w,zoneImage\h)
  	StopDrawing()
	EndIf
	If ydescription = 0
		yDescription = multiLineScrollText(lieu(salle) + findDirections(salle),zoneDescription\x,zoneDescription\y,zoneDescription\w,zoneDescription\h,2,2,yDescription,0,0,0)
	EndIf
	If yInventaire = 0
		iv$ = getObjectList(salle)
		If iv$ = ""
		  iv$ = sys(7)
		EndIf
		StartDrawing(ImageOutput(0))
		DrawImage(ImageID(invBuffer),zoneInventaire\x,zoneInventaire\y)
		StopDrawing()
		yInventaire = multiLineScrollText(sys(0)+" "+iv$,zoneInventaire\x,zoneInventaire\y,zoneInventaire\w,zoneInventaire\h,2,2,yInventaire,0,0,0)
	EndIf
	yTexte = multiLineScrollText(sys(1),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0) ; A vous :
	EvenementsMajeurs()
	screenBuffer = GrabImage(0, #PB_Any, 0, 0, 800, 600)
	textBuffer = GrabImage(0, #PB_Any, zoneTexte\x + 2,zoneTexte\y + 2 + yTexte, zoneTexte\w - 4, zoneTexte\h - 4 - yTexte)
	finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
	Flip()
	StartDrawing(ImageOutput(0))
	DrawImage(ImageID(finalImage),0,0)
	StopDrawing()
	phrase$ = ""
	ok = #False
	While ok = #False And choixFinDeJeu = #False And choixRecommencer = #False
		ch = 0
		While ch = 0
		  ExamineEvents()
  		If KeyEscape = #True
			  sortie = #True
  			Break(2)
	  	EndIf
			ch = GetKey
		  If KeyBack = #True
		    ch = 8
		  ElseIf KeyReturn = #True
		    ch = 13
		  EndIf
		  If ch = 8 And phrase$ <> ""
			  phrase$ = Left(phrase$,Len(phrase$) - 1)
			  StartDrawing(ImageOutput(0))
				DrawImage(ImageID(screenBuffer),0,0)
				DrawImage(ImageID(textBuffer),zoneTexte\x + 2,zoneTexte\y + 2 + yTexte)
				DrawingMode(#PB_2DDrawing_Transparent)
				FrontColor(RGB(0,0,0))
				DrawingFont(FontID(0))
				DrawText(zoneTexte\x + 2,zoneTexte\y + 2 + yTexte, phrase$)
				StopDrawing()
				finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
    		Flip()
			  StartDrawing(ImageOutput(0))
				DrawImage(ImageID(finalImage),0,0)
				StopDrawing()
			ElseIf ch = 13
				ok = #True
				Break
			ElseIf ch > 31
				If GetTextWidth(phrase$ + Chr(ch)) <= zoneTexte\w - 4
					c$ = Chr(ch)
					Select c$
						Case "à","â","ä"
							c$ = "a"
						Case "é","è","ê","ë"
							c$ = "e"
						Case "î","ï"
							c$ = "i"
						Case "ô","ö"
							c$ = "o"
						Case "ù","û","ü"
							c$ = "u"
						Case "ÿ"
							c$ = "y"
						Case "ç"
							c$ = "c"
					EndSelect
					phrase$ = phrase$ + c$
					phrase$ = UCase(phrase$)
					StartDrawing(ImageOutput(0))
					DrawImage(ImageID(screenBuffer),0,0)
					DrawImage(ImageID(textBuffer),zoneTexte\x + 2,zoneTexte\y + 2 + yTexte)
					DrawingMode(#PB_2DDrawing_Transparent)
					FrontColor(RGB(0,0,0))
					DrawingFont(FontID(0))
					DrawText(zoneTexte\x + 2,zoneTexte\y + 2 + yTexte,phrase$)
					StopDrawing()
					finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
      		Flip()
					StartDrawing(ImageOutput(0))
					DrawImage(ImageID(finalImage),0,0)
					StopDrawing()
				EndIf
			EndIf
		Wend
	Wend
	compteurActions + 1
  StartDrawing(ImageOutput(0))
  DrawImage(ImageID(screenBuffer),0,0)
  StopDrawing()
	memPhrase$ = phrase$
	decomposerPhrase(phrase$)
	phrase$ = ""
	For i = 0 To 5
		phrase$ + mot(i)
		If i < 5
		  phrase$ + " "
		EndIf
	Next
	yTexte = multiLineScrollText(memPhrase$,zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
	i = 0
	While i < nbmots
		flagFound = #False
		For j = 0 To 255
			For k = 0 To 9
				If verb(j,k) = mot(i) And flagFound = #False
					flagFound = #True
				EndIf
			Next
		Next
		If flagFound = #False
		  mot(i) = ""
		EndIf
		i + 1
	Wend
	j = 0
	For i = 0 To 5
		If mot(j) = ""
			For k = j To 4
				mot(k) = mot(k + 1)
			Next
			mot(5) = ""
			j - 1
		EndIf
		j + 1
	Next
	nbmots = 0
	For i = 0 To 5
	  If mot(i) <> ""
	    nbmots + 1
	  EndIf
	Next
	For i = 0 To 5
		numeroMot(i) = 255
	Next 
	For i = 0 To nbmots - 1
		For j = 0 To 255
			For k = 0 To 9
				If verb(j,k) = mot(i)
					numeroMot(i) = j 
				EndIf
			Next
		Next			
	Next
	; Verbes/actions prédéfinis
	If nbmots = 0
		If choixFinDeJeu = #False And choixRecommencer = #False
			yTexte = multiLineScrollText(sys(2),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)	
		EndIf
	ElseIf nbmots = 1
		Select numeroMot(0) ; Tester les avancées dans des directions (et autres verbes sans objets)
			Case 0
				 If dir(salle,0) < 253
					salle = dir(salle,0)
					clearScreen = #True
				Else
					yTexte = multiLineScrollText(sys(3),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)	
				EndIf
			Case 1
				 If dir(salle,1) < 253
					salle = dir(salle,1)
					clearScreen = #True
				Else
					yTexte = multiLineScrollText(sys(3),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)	
				EndIf
			Case 2
				 If dir(salle,2) < 253
					salle = dir(salle,2)
					clearScreen = #True
				Else
					yTexte = multiLineScrollText(sys(3),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)	
				EndIf

			Case 3
				 If dir(salle,3) < 253
					salle = dir(salle,3)
					clearScreen = #True
				Else
					yTexte = multiLineScrollText(sys(3),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)	
				EndIf

			Case 4
				 If dir(salle,4) < 253
					salle = dir(salle,4)
					clearScreen = #True
				Else
					yTexte = multiLineScrollText(sys(3),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)	
				EndIf

			Case 5
				 If dir(salle,5) < 253
					salle = dir(salle,5)
					clearScreen = #True
				Else
					yTexte = multiLineScrollText(sys(3),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)	
				EndIf
			Case 6,7,8,9
				yTexte = multiLineScrollText(sys(2),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
			Case 10
				yInventaire = 0
				iv$ = getObjectList(254)
				If iv$ = ""
				  iv$ = sys(7)
				EndIf
				StartDrawing(ImageOutput(0))
				DrawImage(ImageID(invBuffer),zoneInventaire\x,zoneInventaire\y)
				StopDrawing()
				yInventaire = multiLineScrollText(sys(5)+" "+iv$,zoneInventaire\x,zoneInventaire\y,zoneInventaire\w,zoneInventaire\h,2,2,yInventaire,0,0,0)
			Case 11
				yTexte = multiLineScrollText(sys(8),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				yTexte = multiLineScrollText(sys(21)+"/"+sys(22),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				choixFinDeJeu = #True				
			Case 12
				yTexte = multiLineScrollText(sys(23),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
    		Flip()
				StartDrawing(ImageOutput(0))
				DrawImage(ImageID(finalImage),0,0)
				StopDrawing()
				ExamineEvents()
				kp = 0
				While kp = 0
				  If GetKey >= 48 And GetKey <= 57
				    kp = GetKey - 48
				  EndIf
  				ExamineEvents()
				Wend
				If SaveAGame(Str(kp)+".sav") = #False
					yTexte = multiLineScrollText(sys(25),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				EndIf
			Case 13
				clearScreen = #True
				yTexte = multiLineScrollText(sys(23),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
    		Flip()
				StartDrawing(ImageOutput(0))
				DrawImage(ImageID(finalImage),0,0)
				StopDrawing()
				ExamineEvents()
				kp = 0
				While kp = 0
				  If GetKey >= 48 And GetKey <= 57
				    kp = GetKey - 48
				  EndIf
  				ExamineEvents()
				Wend
				If LoadAGame(Str(kp)+".sav") = #False
					yTexte = multiLineScrollText("Sauvegarde inexistante !",zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
  				finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
      		Flip()
		  		StartDrawing(ImageOutput(0))
			  	DrawImage(ImageID(finalImage),0,0)
				  StopDrawing()
					Delay(3000)
				EndIf
		EndSelect
	ElseIf nbmots = 2
		Select numeroMot(0)
			Case 0,1,2,3,4,5,10,11,12,13
				yTexte = multiLineScrollText(sys(4),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
			Case 6
				obj1 = trouveObjet(numeroMot(1),salle)
				If obj1 = -1
					yTexte = multiLineScrollText(sys(17),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				ElseIf attr(obj1,0) = 254 Or attr(obj1,0) = 255
					yTexte = multiLineScrollText(sys(16),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				Else
					If attr(obj1,1) = #True And invCount() < maxInv
						objLieu(obj1) = 254
						clearScreen = #True
					ElseIf attr(obj1,1) = #False
						yTexte = multiLineScrollText(sys(4),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)					
					Else
						yTexte = multiLineScrollText(sys(18),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)					
					EndIf
				EndIf
			Case 7
				obj1 = trouveObjet(numeroMot(1),254)
				If obj1 = -1
				  obj1 = trouveObjet(numeroMot(1),255)
				EndIf
				If obj1 > -1
					objLieu(obj1) = salle
					clearScreen = #True
				Else
					yTexte = multiLineScrollText(sys(19),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				EndIf
			Case 8
				obj1 = trouveObjet(numeroMot(1),255)
				If obj1 > -1
					objLieu(obj1) = 254
				Else
					yTexte = multiLineScrollText(sys(14),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				EndIf
			Case 9
				obj1 = trouveObjet(numeroMot(1),254)
				If obj1 > -1
					If mainCount() < maxMain
						objLieu(obj1) = 255
					Else
						yTexte = multiLineScrollText(sys(15),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
					EndIf
				Else
					yTexte = multiLineScrollText(sys(19),zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
				EndIf
		EndSelect
	EndIf
	If nbmots = 1
		EvenementsMineurs(numeroMot(0),255,255)
	ElseIf nbmots = 2
		EvenementsMineurs(numeroMot(0),numeroMot(1),255)
	ElseIf nbmots >= 2
		EvenementsMineurs(numeroMot(0),numeroMot(1),numeroMot(2))
	EndIf
	yTexte = multiLineScrollText(" ",zoneTexte\x,zoneTexte\y,zoneTexte\w,zoneTexte\h,2,2,yTexte,0,0,0)
	screenBuffer = GrabImage(0, #PB_Any, 0, 0, 800, 600)
	textBuffer = GrabImage(0, #PB_Any, zoneTexte\x + 2,zoneTexte\y + 2 + yTexte, zoneTexte\w - 4, zoneTexte\h - 4 - yTexte)
	finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
	Flip()
	StartDrawing(ImageOutput(0))
	DrawImage(ImageID(finalImage),0,0)
	StopDrawing()
	If choixFinDeJeu = #True
	  While choixFinDeJeu = #True
	    ExamineEvents()
	    myChr$ = Chr(GetKey)
	    While myChr$ = ""
  	    ExamineEvents()
	      myChr$ = Chr(GetKey)
	    Wend  
			If LCase(myChr$) = LCase(Left(sys(21),1))
				sortie = #True
				Break
			ElseIf LCase(myChr$) = LCase(Left(sys(22),1))
				Break
			EndIf
		Wend
		choixFinDeJeu = #False
	EndIf
	If choixRecommencer = #True
		While choixRecommencer = #True
			ExamineEvents()
	    myChr$ = Chr(GetKey)
	    While myChr$ = ""
  	    ExamineEvents()
	      myChr$ = Chr(GetKey)
	    Wend  
			If LCase(myChr$) = LCase(Left(sys(21),1))
				compteurActions = 0
				clearScreen = #True
				salle = 0
				For i= 0 To 5
					mot(i) = ""
				Next
				nbmots = 0 ; Nombre de mots dans la phrase (6 maxi validés)
				For i = 0 To 255
					imgLieu(i) = i
					flags(i) = 0
				Next
				phrase$ = ""
				LoadAGame("0.sav")
				Break
			ElseIf LCase(myChr$) = LCase(Left(sys(22),1))
				sortie = #True
				Break
			EndIf
		Wend
		choixRecommencer = #False
	EndIf
	finalImage = GrabImage(0, #PB_Any, 0, 0, 800, 600)
	Flip()
	StartDrawing(ImageOutput(0))
	DrawImage(ImageID(finalImage),0,0)
	StopDrawing()
Until sortie = #True
LoadAGame("0.sav")
StopSound(#PB_All)
For i = 0 To 255
	ogg(i) = 0
Next
EndProcedure
; IDE Options = PureBasic 5.41 LTS (Windows - x64)
; CursorPosition = 1637
; FirstLine = 1611
; Folding = ------
; EnableUnicode
; EnableXP